<template>
  <div>
    <header-slot>
      <h1>Кошик</h1>
      <div class="prod">
        <product-card-for-cart v-for="prod in getProducts" :key="prod" :product-obj="prod"></product-card-for-cart>
      </div> <br />
      <div class="order"><button @click="buy()">Оформити все</button></div>
    </header-slot>
  </div>
</template>

<script>
import HeaderSlot from "@/components/HeaderSlot.vue";
import ProductCardForCart from "@/components/ProductCardForCart.vue";
import {mapActions, mapGetters} from "vuex";
export default {
  name: 'CartPage',

  components: {
    HeaderSlot, ProductCardForCart
  },

  computed: {
    ...mapGetters('auth', ['getUser']),
    ...mapGetters(['getProducts'])
  },

  methods: {
    ...mapActions(['onDeleteProduct', 'onClearProducts']),
    ...mapActions('orders', ['addItem', 'loadList']),
    ...mapActions('laptops', ['deleteItem', 'loadList']),

    buy() {
      if (this.getUser !== null) {
        const products = JSON.parse(JSON.stringify(this.getProducts))
        products.forEach((el) => this.addItem(el))
        products.forEach((el) => this.deleteItem(el.id))
        this.onClearProducts()
        alert('Замовлення оформлено!')
      }
      else {
        alert('Потрібно авторизуватись')
      }
    },
  },

  async created() {
    await this.loadList();
  }
}
</script>

<style lang="css" scoped>
.prod{
  display: flex;
  flex-wrap: wrap;
  margin-top: 15px;
  margin-right: 10px;
}

.order button{
  width: 200px;
  height: 50px;
  padding: 10px 20px;
  border: none;
  border-radius: 4px;
  cursor: pointer;
  transition: background-color 0.2s;
}

.order button:hover {
  background-color: crimson;
  color: #fff;
}
</style>